package com.lucaszanella.flutterplugincrashrestartkt

import android.content.ContentValues.TAG
import android.util.Log
import androidx.annotation.NonNull;
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import java.util.*

/** FlutterplugincrashrestartktPlugin */
public class FlutterplugincrashrestartktPlugin: FlutterPlugin, MethodCallHandler {
  //private val CHANNEL = "samples.flutter.dev/battery"
  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    val channel = MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "flutterplugincrashrestarterkt")
    channel.setMethodCallHandler(FlutterplugincrashrestartktPlugin());
  }

  // This static function is optional and equivalent to onAttachedToEngine. It supports the old
  // pre-Flutter-1.12 Android projects. You are encouraged to continue supporting
  // plugin registration via this function while apps migrate to use the new Android APIs
  // post-flutter-1.12 via https://flutter.dev/go/android-project-migration.
  //
  // It is encouraged to share logic between onAttachedToEngine and registerWith to keep
  // them functionally equivalent. Only one of onAttachedToEngine or registerWith will be called
  // depending on the user's project. onAttachedToEngine or registerWith must both be defined
  // in the same class.
  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "flutterplugincrashrestartkt")
      channel.setMethodCallHandler(FlutterplugincrashrestartktPlugin())
    }
  }
  /*
  override fun configureFlutterEngine(@NonNull flutterEngine: FlutterEngine) {
    MethodChannel(flutterEngine.dartExecutor.binaryMessenger, CHANNEL).setMethodCallHandler {
      call, result ->
      if (call.method == "crash") {
        FlutterExceptionHandler.crashMe()
      } else if (call.method.equals("getStackTrace")) {
        if (FlutterExceptionHandler.hasStackTrace) {
          val resultMap = HashMap<String, Any>()
          resultMap.put("message", FlutterExceptionHandler.message)
          resultMap.put("cause", FlutterExceptionHandler.cause)
          resultMap.put("stackTrace", FlutterExceptionHandler.stackTrace)
          resultMap.put("didCrash", true)
          result.success(resultMap)
        } else {
          result.success(false)
        }
      } else {
        result.notImplemented()
      }
    }
  }
  */
  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    if (call.method == "crash") {
      FlutterExceptionHandler.crashMe()
    } else if (call.method == "getStackTrace") {
      if (FlutterExceptionHandler.hasStackTrace) {
        val resultMap = HashMap<String, Any>()
        resultMap.put("message", FlutterExceptionHandler.message)
        resultMap.put("cause", FlutterExceptionHandler.cause)
        resultMap.put("stackTrace", FlutterExceptionHandler.stackTrace)
        resultMap.put("didCrash", true)
        result.success(resultMap)
      } else {
        result.success(false)
      }
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
  }
}
